'''
Created on Apr 6, 2017

@author: breno
'''

import pprint
import random
import os
import sys
import logging
import subprocess
import shutil
from pickle import dump, load
#from pprint import pprint
import numpy as np

#from gen_tcs_gzip import TestGenGzip
#from op_gzip import refresh_dict
#from aux import gen_info_file, run_cmd, compile_cov, reset_gcda
#import config

#print('\n'.join(sys.path))
sys.path.insert(0, '/home/breno/workspace/icseexp')  # coverage_info
sys.path.insert(0, '/home/breno/workspace/icseexp/experiment')  # apfdc_main
#print('\n'.join(sys.path))
import similarity_info_files
import apfdc_main
from coverage_info import merge_lcov_files



def get_order_op_for_tc_gen_np(num_tcs, ocurrence_probabilities):
    return np.random.choice(ocurrence_probabilities.keys(), num_tcs, p=ocurrence_probabilities.values()).tolist()

def get_order_op_for_tc_gen(num_tcs, ocurrence_probabilities, shuffle=False):
    op_order = []
    numtcs_per_op = {}
    numtcs_per_op_print = {}
    operations = ocurrence_probabilities.keys()
    for op in operations:
        oc_prob = ocurrence_probabilities[op]
        num_tcs_op = int(round(num_tcs * oc_prob, 0))
        numtcs_per_op[op] = num_tcs_op
        for _ in range(num_tcs_op):
            op_order.append(op)
    #
    for k in numtcs_per_op:
        numtcs_per_op_print[k] = str(numtcs_per_op[k])
    #
    while len(op_order) < num_tcs:        
        rand_op = random.choice(operations)
        op_order.append(rand_op)
        numtcs_per_op[rand_op] += 1
        #print "[add] ocurrence_probabilities: ", ocurrence_probabilities, rand_op
        #debug()
        numtcs_per_op_print[rand_op] += " (+1)"        
    while len(op_order) > num_tcs:
        #rand_op = random.choice(operations)
        idx = random.randrange(len(op_order))
        del_op = op_order[idx]
        op_order.pop(idx)
        numtcs_per_op[del_op] -= 1
        numtcs_per_op_print[rand_op] += " (-1)"
        #print "[rem] ocurrence_probabilities: ", ocurrence_probabilities, idx, del_op
        #debug()
    if shuffle:
        random.shuffle(op_order)
    assert len(op_order) == num_tcs, "There is something wrong"
    #print numtcs_per_op_print
    return op_order, numtcs_per_op, numtcs_per_op_print

def write_tc_to_sh_file(tc, tc_id, outfile):
    with open(outfile, 'w') as f:
        os.chmod(outfile, 0764)
        f.write('#!/bin/sh' + '\n')
        f.write('\n')
        f.write('echo ">>>>>>>>running test {}"'.format(tc_id) + '\n')
        f.write(tc + '\n')
        f.write('echo "cleaning up"' + '\n')
        f.write(os.path.join(subject_dir, 'cleanup.sh') + " " + "../subjects" + '\n')
        f.write('echo "done"' + '\n')

def get_cumulative_spectrum(lcov_files_list, outfile):
    logging.debug("lcov_files_list: {}".format(lcov_files_list))
    logging.debug("outfile: {}".format(outfile))
    merge_lcov_files(lcov_files_list, outfile)
    
def cleanup():
    outdir = os.path.join(version_dir, 'covrel_generation')
    if os.path.exists(outdir):
        shutil.rmtree(outdir)    
    
def debug():
    raw_input("Press 'enter' to continue...")
    
def transform_data(list_):
    ret = ""
    for e in list_:
        ret += "{} ".format(e)
    return ret.strip()

def get_allocation_old(cmd):
    p = subprocess.Popen(cmd, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
    stdout, stderr = p.communicate()
    return stdout

def get_allocation(num_part, fail_rates, prev_fail_rates, similarities, prev_sim_fail_rate_balance_factors,
                   ocurrence_probabilities, prev_IS_prob, prev_tc_per_part):
    # Prepare cmd
    cmd = ["/usr/bin/java", "-jar", "getAllocation.jar"]
    cmd.append(str(num_part))  # arg0            
    cmd.append(transform_data(fail_rates))  # arg1
    cmd.append(transform_data(prev_fail_rates))  # arg2
    cmd.append(transform_data(similarities))  # arg3
    cmd.append(transform_data(prev_sim_fail_rate_balance_factors))  # arg4
    cmd.append(transform_data(ocurrence_probabilities))  # arg5
    cmd.append(transform_data(prev_IS_prob))  # arg6
    cmd.append(transform_data(prev_tc_per_part))  # arg7
    logging.info("cmd: {}".format(cmd))
    logging.info("cmd (ready): {}".format('" "'.join(cmd)))    
    #log.write("{}\n".format(cmd))
    
    # Run cmd
    p = subprocess.Popen(cmd, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
    stdout, stderr = p.communicate()
    
    # Check stdout
    if not stdout:
        print "Something wrong happened: \n", stderr
        #logging.info("cmd-prev_IS_prob: {}".format(prev_IS_prob))
        exit()   
    
    if "NaN" in stdout:
        print "'NaN'Problem! \n stdout: {} \n stderr: {}".format(stdout, stderr)     
    
    # Parse stdout
    aux = stdout.strip().split(',')
    num_partitions = int(aux[0])
    tc_per_part = [int(ntc) for ntc in aux[1].strip().split(" ")]
    IS_prob = [float(prob) for prob in aux[2].strip().split(" ")]
    assert sum(IS_prob) > 0, "IS_prob Error: {} | aux: {} | stdout: {}".format(IS_prob, aux, stdout)
    #for e in IS_prob:
        #assert isinstance(e, (int, long, float, complex)), "IS_prob: {}".format(IS_prob)
        #assert isinstance(e, (int, float)), "IS_prob: {}".format(IS_prob)    
    sim_fail_rate_balance_factors = [float(sim) for sim in aux[3].strip().split(" ")]
    return tc_per_part, IS_prob, sim_fail_rate_balance_factors

def parse_allocation_stdout(stdout_):
    # UPDATE THIS WITH PROPER PARSER LATER
    #total_tc_next_iter = 66
    #tc_per_part_next_iter = [14,13,13,13,13]
    #IS_prob = [0.2,0.2,0.2,0.2,0.2]
    #sim_fail_rate_balance_factors = [1.0,1.0,1.0,1.0,1.0]
    #return tc_per_part_next_iter, IS_prob, sim_fail_rate_balance_factors
    #=====
    aux = stdout_.strip().split(',')
    num_partitions = int(aux[0])
    tc_per_part_next_iter = [int(ntc) for ntc in aux[1].strip().split(" ")]
    IS_prob = [float(prob) for prob in aux[2].strip().split(" ")]
    sim_fail_rate_balance_factors = [float(sim) for sim in aux[3].strip().split(" ")]
    return tc_per_part_next_iter, IS_prob, sim_fail_rate_balance_factors
    
        



def main_new():    
    #objTestGroup1 = TestGenGzip(subject, version)
    #objTestGroup1 = TestGenGzip(subject, version, testtype='SIR')
    tc_id = 1
    tc_id_global = 1
    history = {}
    faults_revealed_aux = []
    faults_revealed_tcid_aux = []
    faults_revealed = []
    faults_revealed_tcid = []
    #---
    final_ts = []
    
    def _select_and_run_tcs(tc_id, tc_per_part):
        global_ts = []
        fail_rates = []
        fail_per_part = []
        fm_iteration = [0 for _ in fm]
        for i in range(len(operations)):
            op = operations[i]
            numtcs = tc_per_part[i]
            #logging.info("OP: {:>2} | #TCs: {:>3}".format(op, numtcs))
            if numtcs == 0:
                logging.debug("No TCs will be generated for OP{} at this iteration".format(op))
                logging.debug("Copying OP{}_iter{}.info file to the current iteration directory".format(op, iteration))
                src = os.path.join(version_dir, 'covrel_generation', 'iter{}'.format(iteration-1), 'OP{}_iter{}.info'.format(op, iteration-1))
                dst_dir = os.path.join(version_dir, 'covrel_generation', 'iter{}'.format(iteration))
                if not os.path.exists(dst_dir):
                    os.makedirs(dst_dir)
                dst = os.path.join(dst_dir, 'OP{}_iter{}.info'.format(op, iteration))
                shutil.copy(src, dst)
                fail_rates.append(0.0)
                fail_per_part.append(0)
                continue
            
            ts = random.sample(pool[op], numtcs)
            global_ts.extend(ts)
            logging.debug("test suite for OP {}:\n{}".format(op, pprint.pformat(ts)))
            #===================================================================
            # Failure rate
            count_faults = 0
            flag = 0
            for tc in ts:
                if tc in fm_tc:
                    new_faults = [f for f in fm_tc[tc] if f not in faults_revealed_aux]
                    if new_faults:
                        logging.info("New fault(s) found: {}".format(new_faults))
                        count_faults += len(new_faults)
                        logging.info("TC ID {} (tc_{}) from OP {} fails: {} ({})".format(tc_id, tc, op, new_faults, faults_revealed_aux))                    
                        for fault in new_faults:
                            faults_revealed_aux.append(fault)
                            faults_revealed_tcid_aux.append(tc_id)
                            fault_pos = sorted(fm.keys()).index(fault)
                            fm_iteration[fault_pos] = 1
                    
                    if len(faults_revealed_aux) == len(all_faults):
                        logging.debug("All faults have been found! (tc id: {})".format(tc_id))
                        #return fail_rates, tc_id, global_ts
            
            fail_rate = count_faults/float(numtcs)            
            fail_rates.append(fail_rate)
            fail_per_part.append(count_faults)
            logging.info("OP: {:>2} | #TCs: {:>3} | Fail rate: {} | Fail per part: {}".format(op, numtcs, fail_rate, fail_per_part))
            #===================================================================
            # Move individual coverage files to iteration output directory 
            #(this step can be skipped if files are merged directly from the pool dir)
            for tc in ts:
                src = os.path.join(pool_dir, 'individual_test_coverage', '{}.info'.format(tc))
                dst = os.path.join(iter_outdir, '{}.info'.format(tc))        
                shutil.copy(src, dst)
                #print "TC {} == {}".format(tc_id, tc)
                tc_id += 1
            #===================================================================
            # Generate cumulative OP info file
            outfile = os.path.join(iter_outdir, 'OP{}_iter{}.info'.format(op, iteration))#+1))                
            lcov_files_list = [os.path.join(iter_outdir, '{}.info'.format(tc)) for tc in ts]
            merge_lcov_files(lcov_files_list, outfile)
            #===================================================================
            if iteration > 0:
                auxfile = os.path.join(iter_outdir, 'OP{}_iter{}_aux.info'.format(op, iteration))#+1))
                os.rename(outfile, auxfile)
                #previous_iter_outdir = os.path.join(version_dir, 'covrel_generation', 'iter{}'.format(iteration))
                previous_iter_outdir = os.path.join(version_dir, 'covrel_generation', 'iter{}'.format(iteration-1))
                #previous_info_file = os.path.join(previous_iter_outdir, 'OP{}_iter{}.info'.format(op, iteration))
                previous_info_file = os.path.join(previous_iter_outdir, 'OP{}_iter{}.info'.format(op, iteration-1))
                newoutfile = os.path.join(iter_outdir, 'OP{}_iter{}.info'.format(op, iteration))#+1)) 
                lcov_files_list = [auxfile, previous_info_file]
                merge_lcov_files(lcov_files_list, newoutfile)
            #===================================================================
            # Finished running all TCs for a given OP: cleaning up coverage info
        #fail_rates = [random.random() for _ in operations]
        logging.debug("fail_rates: {}".format(fail_rates))
        assert(len(fail_rates) == len(ocurrence_probabilities)), "Error!"
        assert(len(fail_per_part) == len(ocurrence_probabilities)), "Error!"
        return fail_rates, fail_per_part, fm_iteration, tc_id, global_ts

    # ===================================================================    
    # START HERE 
    # ===================================================================
    for iteration in range(num_iterations):
        print "{}\nIteration #{}\n{}".format('-'*50, iteration, '-'*50)#+1, '='*50)
        logging.info("{} fault(s) missing".format(len(all_faults)-len(faults_revealed)))
        iter_outdir = os.path.join(version_dir, 'covrel_generation', 'iter{}'.format(iteration))#+1))
        if not os.path.isdir(iter_outdir):
            os.makedirs(iter_outdir)
            
        if iteration == 0:   
            # Info from previous iteration
            prev_fail_rates = [1.0 for _ in range(partitions)]
            prev_sim_fail_rate_balance_factors = [1.0 for _ in range(partitions)]
            prev_IS_prob = [0.0 for _ in range(partitions)]
            prev_tc_per_part = [1 for _ in range(partitions)]
            # if iteration = 0
            IS_prob = prev_IS_prob[:]
            logging.info("Iter {} - IS_prob: {}".format(iteration, IS_prob))
            tc_per_part = prev_tc_per_part[:]     
            
            if iteration not in history:
                history[iteration] = {}
                logging.info("Iter {} added to history".format(iteration))
            history[iteration].update({'fail_rates': prev_fail_rates[:]})
            history[iteration].update({'sim_fail_rate_balance_factors': prev_sim_fail_rate_balance_factors[:]})
            logging.info("[History-Update] Iter {} - {}".format(iteration, history[iteration]))
        else:
            # Info from previous iteration
            prev_fail_rates = history[iteration-1]['fail_rates']            
            prev_sim_fail_rate_balance_factors = history[iteration-1]["sim_fail_rate_balance_factors"] 
            prev_IS_prob = history[iteration-1]['IS_prob']
            prev_tc_per_part = history[iteration-1]['tc_per_part']
            logging.info("""\nFrom previous iteration:
                        prev_fail_rates: {}
                        prev_sim_fail_rate_balance_factors: {}
                        prev_IS_prob: {}
                        prev_tc_per_part: {}""".format(prev_fail_rates, prev_sim_fail_rate_balance_factors, prev_IS_prob, prev_tc_per_part))            
            # Info from current iteration
            fail_rates = history[iteration]['fail_rates']
            similarities = history[iteration]['sim_fail_rate_balance_factors']
            logging.info("""\nFrom current iteration:
                        fail_rates: {}
                        similarities: {}""".format(fail_rates, similarities))
            
            tc_per_part, IS_prob, sim_fail_rate_balance_factors = get_allocation(partitions, 
                    fail_rates, prev_fail_rates, similarities, prev_sim_fail_rate_balance_factors,
                    ocurrence_probabilities.values(), prev_IS_prob, prev_tc_per_part)
            assert sum(IS_prob) > 0, "IS_prob error: {}".format(IS_prob)
        #===================================================================   
        # Common part
        print "{} test cases will be generated for iteration {}".format(sum(tc_per_part), iteration)#+1)
        fail_rates,fail_per_part, fm_iteration, tc_id, global_ts = _select_and_run_tcs(tc_id, tc_per_part)  # Select and run TCs for each operation
        logging.debug("len global_ts: {}".format(len(global_ts)))
        
        # Get cumulative spectrum for the iteration
        #target_dir = os.path.join(version_dir, 'covrel_generation') 
        lcov_files_list = [os.path.join(iter_outdir, f) for f in os.listdir(iter_outdir) 
                           if f.startswith('OP') and f.endswith('.info') and 'iter{}'.format(iteration) in f
                           and 'aux' not in f]  # Need to filter per iteration and ignore cumulative
        #print "lcov_files_list for iteration {}: {}".format(iteration+1, sorted(lcov_files_list))
        logging.debug("lcov_files_list for cumulative spectrum (iteration {}):\n{}".format(iteration, 
                      pprint.pformat(sorted(lcov_files_list))))
        outfile = os.path.join(iter_outdir, 'ALL_iter{}.info'.format(iteration))
        get_cumulative_spectrum(lcov_files_list, outfile)
        
        sim_dict = similarity_info_files.get_similarity_between_global_and_op(version_dir, iteration, entity, hml_proportion)                        
        similarities = [sim_dict[k] for k in operations]
        assert(len(similarities) == len(ocurrence_probabilities)), "Error!"
        
        #=====
        if iteration not in history:
                history[iteration] = {}
                logging.info("Iter {} added to history".format(iteration))
        history[iteration].update({'tc_per_part': tc_per_part})
        history[iteration].update({'IS_prob': IS_prob})
        history[iteration].update({'tot_tcs': sum(tc_per_part)})
        logging.info("[History-Update] Iter {} - {}".format(iteration, history[iteration]))
        
        history[iteration+1] = {}
        history[iteration+1].update({'sim_fail_rate_balance_factors': similarities})
        #history[iteration+1].update({'sim_fail_rate_balance_factors': sim_fail_rate_balance_factors})
        history[iteration+1].update({'fail_rates': fail_rates})
        history[iteration+1].update({'fail_per_part': fail_per_part})
        history[iteration+1].update({'fm_iteration': fm_iteration})
        logging.info("[History-Update] Iter {} - {}".format(iteration+1, history[iteration+1]))
        #===================================================================
        
        # Global TS 
        logging.debug("global_ts: {}".format(global_ts[:10]))
        random.shuffle(global_ts)
        logging.debug("global_ts: {}".format(global_ts[:10]))
        for tc in global_ts:
            final_ts.append(tc)
            if tc in fm_tc:
                new_faults = [f for f in fm_tc[tc] if f not in faults_revealed]
                if new_faults:
                    logging.debug("New fault(s) found: {}".format(new_faults))
                    logging.debug("TC ID {} (tc_{}) fails: {} ({})".format(tc_id_global, tc, new_faults, faults_revealed))                                        
                    for fault in new_faults:
                        faults_revealed.append(fault)
                        faults_revealed_tcid.append(tc_id_global)
                    print "{}/{} faults found ({} tests)".format(len(faults_revealed), len(all_faults), tc_id_global)
                if len(faults_revealed) == len(all_faults):
                    logging.debug("[!!!] All faults have been found! (tc id: {})".format(tc_id_global))
                    #break # comment this 'break' if we want to have test suites with the same size for covrel and opbt
            tc_id_global += 1
            if tc_id_global > tc_budget:  # maximum tc budget
                print "Maximum tc budget"
                pass
                #break
        logging.info("tc_id_global: {}".format(tc_id_global))            
        #===================================================================
        # End of iteration 
        
        if len(faults_revealed) == len(faults_revealed_aux) == len(all_faults):
            print "Breaking (all faults revealed) {}/{} after {} tests".format(len(faults_revealed), len(all_faults), faults_revealed_tcid[-1])
            logging.info("Breaking (all faults revealed) {}/{} after {} tests".format(len(faults_revealed), len(all_faults), faults_revealed_tcid[-1]))
            break   
        
        if tc_id_global > tc_budget:
            print "Breaking (budget consumed)... faults revealed {}/{}".format(len(faults_revealed),len(all_faults))
            logging.info("Breaking (budget consumed)... faults revealed {}/{}".format(len(faults_revealed),len(all_faults)))
            break
        
        #print "History: ", history
    
    apfd = apfdc_main.calculate_apfd(final_ts, fm_tc, flag='covrel')
    return faults_revealed_tcid, faults_revealed_tcid_aux, history, final_ts, apfd


def store_opbt_info(tc_per_part_opbt, fail_per_part_opbt, fm_iteration_opbt):
    opbt_tcpart = os.path.join(run_outdir, '{}-{}-tcs_per_part.txt'.format("opbt", entity))
    opbt_failpart = os.path.join(run_outdir, '{}-{}-failures_per_part.txt'.format("opbt", entity))
    opbt_fm_iter = os.path.join(run_outdir, '{}-{}-fm_per_iteration.txt'.format("opbt", entity))
    with open(opbt_tcpart, 'a') as opbt_tcpartout, \
        open(opbt_failpart, 'a') as opbt_failpartout, \
        open(opbt_fm_iter, 'a') as opbt_fm_iterout:
            for numtc in tc_per_part_opbt:
                opbt_tcpartout.write("{} ".format(numtc))
            opbt_tcpartout.write("\n")
            for numfail in fail_per_part_opbt:
                opbt_failpartout.write("{} ".format(numfail))
            opbt_failpartout.write("\n")
            for f in fm_iteration_opbt:
                opbt_fm_iterout.write("{} ".format(f))
            opbt_fm_iterout.write("\n") 

def opbt(ocurrence_probabilities):
    faults_revealed = []
    faults_revealed_tcid = []
    vals = ocurrence_probabilities.keys()
    probs = ocurrence_probabilities.values()
    tc_id = 1
    numtcs = 1
    #---
    tc_per_part_opbt = [0 for _ in vals]    
    fail_per_part_opbt = [0 for _ in vals]
    fm_iteration_opbt = [0 for _ in fm]
    #---
    final_ts = []
    
    #===========================================================================
    # def _snapshot(tc_per_part_opbt, fail_per_part_opbt, fm_iteration_opbt):
    #     print "M point {}".format(tc_id)
    #     print "tc_per_part_opbt: ", tc_per_part_opbt
    #     print "fail_per_part_opbt: ", fail_per_part_opbt   
    #     print "fm_iteration_opbt: ", fm_iteration_opbt
    #     assert sum(fail_per_part_opbt) == sum(fm_iteration_opbt), "!= # faults"
    #     store_opbt_info(tc_per_part_opbt, fail_per_part_opbt, fm_iteration_opbt)
    #     tc_per_part_opbt = [0 for _ in vals]    
    #     fail_per_part_opbt = [0 for _ in vals]
    #     fm_iteration_opbt = [0 for _ in fm]
    #===========================================================================
    
    #print "fail_per_part_opbt: ", fail_per_part_opbt
    #print "tc_per_part_opbt: ", tc_per_part_opbt
    
    #while len(faults_revealed) != len(all_faults) and tc_id <= iter_points[-1]:
    #while tc_id <= iter_points[-1]:
    max_ = max(tc_budget, iter_points[-1])
    while tc_id <= max_:     
        #if len(faults_revealed) == len(all_faults):
        #    pass
        op = np.random.choice(vals, p=probs)            
        ts = random.sample(pool[op], numtcs)
        tc_per_part_opbt[op-1] += 1
        logging.debug("test suite for OP {}:\n{}".format(op, pprint.pformat(ts)))            
        for tc in ts:
            final_ts.append(tc)
            if tc in fm_tc:
                new_faults = [f for f in fm_tc[tc] if f not in faults_revealed]
                if new_faults:
                    logging.info("New fault(s) found: {}".format(new_faults))
                    logging.info("TC ID {} (tc_{}) from OP {} fails: {} ({})".format(tc_id, tc, op, new_faults, faults_revealed))
                    fail_per_part_opbt[op-1] += len(new_faults)       
                    #print "fail_per_part_opbt: ", fail_per_part_opbt             
                    for fault in new_faults:
                        faults_revealed.append(fault)
                        faults_revealed_tcid.append(tc_id)
                        fault_pos = sorted(fm.keys()).index(fault)
                        fm_iteration_opbt[fault_pos] = 1
                    print "{}/{} faults found ({} tests)".format(len(faults_revealed), len(all_faults), tc_id)        
                if len(faults_revealed) == len(all_faults):
                    logging.debug("! (tc id: {})".format(tc_id))
                    #break
        if tc_id in iter_points:
            #_snapshot(tc_per_part_opbt, fail_per_part_opbt, fm_iteration_opbt)
            #tc_per_part_opbt = [0 for _ in vals]    
            #fail_per_part_opbt = [0 for _ in vals]
            #fm_iteration_opbt = [0 for _ in fm]
            
            #print "M point {}".format(tc_id)
            #print "tc_per_part_opbt: ", tc_per_part_opbt
            #print "fail_per_part_opbt: ", fail_per_part_opbt   
            #print "fm_iteration_opbt: ", fm_iteration_opbt
            assert sum(fail_per_part_opbt) == sum(fm_iteration_opbt), "!= # faults"
            store_opbt_info(tc_per_part_opbt, fail_per_part_opbt, fm_iteration_opbt)
            tc_per_part_opbt = [0 for _ in vals]    
            fail_per_part_opbt = [0 for _ in vals]
            fm_iteration_opbt = [0 for _ in fm]
        
        if len(faults_revealed) == len(all_faults):
            #print "All faults have been found! (tc id: {})".format(tc_id)
            #raw_input("continue?")
            print "Breaking (all faults revealed) {}/{} after {} tests".format(len(faults_revealed), len(all_faults), tc_id)
            logging.debug("Breaking (all faults revealed) {}/{} after {} tests".format(len(faults_revealed), len(all_faults), tc_id))
            #_snapshot(tc_per_part_opbt, fail_per_part_opbt, fm_iteration_opbt)
            #store_opbt_info(tc_per_part_opbt, fail_per_part_opbt, fm_iteration_opbt)
            #tc_per_part_opbt = [0 for _ in vals]    
            #fail_per_part_opbt = [0 for _ in vals]
            #fm_iteration_opbt = [0 for _ in fm]
            break
        #
        tc_id += 1
    #return faults_revealed_tcid, tc_per_part_opbt, fail_per_part_opbt, fm_iteration_opbt
    if tc_id > max_:
        print "Breaking (budget consumed)... faults revealed {}/{}".format(len(faults_revealed),len(all_faults))
        logging.info("Breaking (budget consumed)... faults revealed {}/{}".format(len(faults_revealed),len(all_faults)))
        #_snapshot(tc_per_part_opbt, fail_per_part_opbt, fm_iteration_opbt)
        #store_opbt_info(tc_per_part_opbt, fail_per_part_opbt, fm_iteration_opbt)
    
    if tc_id > iter_points[-1] + 1: # additional iteration
        store_opbt_info(tc_per_part_opbt, fail_per_part_opbt, fm_iteration_opbt)
    
    #print "final_ts: ", final_ts
    apfd = apfdc_main.calculate_apfd(final_ts, fm_tc, flag='covrel')
    #print "apfd: ", apfd
    #exit()
    #print "Done for OPBT! Faults revealed {}/{}".format(len(faults_revealed),len(all_faults))
    return faults_revealed_tcid, final_ts, apfd
    

def opbt_iter(ocurrence_probabilities):  
    tc_id = 1
    for iter in range(len(history)-1):  # ignore the last dict key
        fail_rates = []
        tot_tcs = history[iter]['tot_tcs']
        print "tot_tcs: ", tot_tcs
        if iter == 0:
            tc_per_part = [1 for _ in range(partitions)]
            print "tc_per_part ({}): {}".format(sum(tc_per_part), tc_per_part)
        if iter > 0:
            tc_per_part = []
            for op in ocurrence_probabilities:
                prob = ocurrence_probabilities[op]                
                num_tcs = tot_tcs * prob
                num_tcs = int(num_tcs)
                print "op: {}, num_tcs: {}, int(num_tcs): {}".format(op, num_tcs, int(num_tcs))
                tc_per_part.append(num_tcs)
            i = 0
            while sum(tc_per_part) < tot_tcs:                
                tc_per_part[i%len(tc_per_part)] += 1
                i += 1
            i = 0
            while sum(tc_per_part) > tot_tcs:                
                tc_per_part[i%len(tc_per_part)] -= 1
                i += 1
            print "tc_per_part ({}): {}".format(sum(tc_per_part), tc_per_part)
        #=====
        for i in range(len(operations)):
            op = operations[i]
            numtcs = tc_per_part[i]

            ts = random.sample(pool[op], numtcs)
            logging.debug("test suite for OP {}:\n{}".format(op, pprint.pformat(ts)))
            #===================================================================
            # Failure rate
            count_faults = 0
            for tc in ts:
                # TEMP: verify failing TCs =====
                if tc in failing_tcs:
                    count_faults += 1                     
                    print "TC ID {} (tc_{}) from OP {} fails!".format(tc_id, tc, op)                
                print "TC ID {} (tc_{}) from OP {}".format(tc_id, tc, op)
                tc_id += 1
            fail_rate = count_faults/float(numtcs)
            print "Fail rate for OP {}: {}".format(op, fail_rate)
            fail_rates.append(fail_rate)
        print "fail_rates: ", fail_rates
            
            

def get_op(num_part):
    def _try():
        aux = np.random.dirichlet(np.ones(num_part),size=1)[0].tolist()
        roun = [max(round(i, 2), 0.01) for i in aux]
        last = 0
        if not sum(roun) == 1:
            last = 1 - sum(roun[:-1])
            #assert last > 0, "Something went wrong... last: {} | roun: {}".format(last, roun)
            roun.pop()
            roun.append(last)
        if last <= 0:
            return None
        return roun

    roun = _try()
    while not roun or sum(roun) != 1.0:
        logging.debug("Retry!")
        roun = _try()    
    print "OP: {} ({})".format(roun, sum(roun))
    assert sum(roun) == 1.0, "Something went wrong: {} {}".format(roun, sum(roun))
    return roun
    #d = {}
    #for i in range(num_part):
    #    d[i+1] = roun[i]
    #print d
    #return d
        

def temp_debug():
    tcpart_covrel = os.path.join(run_outdir, '{}-{}-tcs_per_part.txt'.format("covrel", entity))
    tcpart_opbt = os.path.join(run_outdir, '{}-{}-tcs_per_part.txt'.format("opbt", entity))
    with open(tcpart_covrel, 'r') as fin1, \
        open(tcpart_opbt, 'r') as fin2:
        if len(fin1.readlines()) != len(fin2.readlines()):
            raw_input("Error?") 
                        
if __name__ == '__main__':
    #===========================================================================
    # subject = 'gzip'
    # version = 'v1'
    # pool_dir = '/home/breno/workspace/icseexp/subjects/{}/{}'.format(subject, version) 
    # with open(os.path.join(pool_dir, 'fault_matrix_key_tc.pickle'), 'rb') as fin:
    #     fm_tc = load(fin)
    # aux_ = "4026 1493 8115 4569 2266 375 3480 1425 9688 9622 7294 4229 5838 9886 1293 5616 8851 9183 3493 1491 7250 7053 923 504 2823 1359 8460 1085 8826 3951 1641 5866 5515 5181 7427 5822 1558 872 5230 5397 1966 3579 888 5734 6123 8581 8786 7032 4264 7661 8880 3796 27 7444 8429 8471 7339 5474 4196 4114 6060 6274 5954 375 7174 2973 2967 8173 3921 4336 1269 4858 6100 9043 4352 850 9597 4053 9540 5838 8706 6790 8776 2147 9 4605 4273 1634 3882 4414 2338 9890 2022 5302 4205 8817 3421 9325 9150 5538 1453 6451 3207 1965 3241 9614 2404 1521 1575 1065 2904 6688 731 7008 9839 158 9037 72 6220 1811 8730 9109 8511 3968 5815 9506 8882 351 4885 4195 3801 5797 4569 6805 1482 8291 4907"  
    # final_ts = [int(i) for i in aux_.split()]
    # apfd = apfdc_main.calculate_apfd(final_ts, fm_tc, flag='covrel')
    # print "apfd: ", apfd
    # exit()
    #===========================================================================
    
    DEBUG_MODE = 1
    exp_flag = "continue_until_all_faults"
    
    #logging.basicConfig(level=logging.DEBUG)    
    #logging.basicConfig(level=logging.INFO)
    logging.basicConfig(level=logging.WARN)
       
    #subject, version = 'gzip', 'v4'  # Done    
    #subject, version = 'grep', 'v3'  # Done
    #subject, version = 'sed', 'v2'  # Done
    
    entities = ['function', 'line', 'branch']
    #entities = ['branch']
    #entities = ['function']    
    #entity = 'function'
    
    num_runs = 30    
    tc_budget = 10000        
    num_iterations = 1000  # any big number as the experiment finishes when all faults are found    
    hml_proportion = (1/3.0, 1/3.0, 1/3.0)    
    
    subjects = ['gzip', 'flex', 'sed', 'grep']
    subjects = ['grep']
    #subjects = ['gzip']
    
    if DEBUG_MODE:
        num_runs = 30
        tc_budget = 10000  
        #subjects = ['gzip']
        #subjects = ['sed', 'flex', 'grep']
        #entities = ['function']
        #pass
        
    for subject in subjects:
        if subject == 'gzip':
            versions = ['v1', 'v2', 'v4', 'v5']  # gzip
            if DEBUG_MODE:
                versions = ['v1']  # debug only
        if subject == 'grep':
            versions = ['v1', 'v2', 'v3', 'v4']  # grep
            if DEBUG_MODE:
                versions = ['v1']  # debug only
        if subject == 'sed':
            versions = ['v2', 'v3', 'v5', 'v6']  # sed
            if DEBUG_MODE:
                versions = ['v4']  # debug only
        if subject == 'flex':
            versions = ['v1', 'v2', 'v3', 'v4']  # flex
            if DEBUG_MODE:
                versions = ['v1']  # debug only
                #versions = ['v1', 'v2', 'v3', 'v4']
        #versions = ['v1']  # debug only 
        
        subject_dir = os.path.join('..', 'subjects', subject)
    
        if not os.path.isdir(subject_dir):
            os.makedirs(subject_dir)
    
        for version in versions:
            version_dir = os.path.join(subject_dir, version)
            cleanup()    
                
            if not os.path.isdir(version_dir):
                os.makedirs(version_dir)
            
            outdir = os.path.join(version_dir, 'covrel_generation', 'testcases')
            if not os.path.isdir(outdir):
                os.makedirs(outdir)
                
            resdir = os.path.join('..','results', subject, version)
            if not os.path.isdir(resdir):
                os.makedirs(resdir)
            
            #===========================================================================
            # exe_dir = os.path.join(version_dir, 'src')    
            # if not os.path.isfile(os.path.join(exe_dir, '{}.exe'.format(subject))):
            #     logging.info('Compiling {} version {} (cwd: {})'.format(subject, version, exe_dir))
            #     compile_cov(subject, exe_dir)
            #     logging.info('Done!')
            #===========================================================================
            
            #===========================================================================
            # try:   
            #     covfilter = config.CONFIG[subject]['covfilter']
            # except KeyError:
            #     covfilter = None
            #===========================================================================
                
            #===========================================================================
            if subject == 'gzip':
                num_part = 5
            if subject == 'grep':
                num_part = 4
            if subject == 'sed':
                num_part = 3
            if subject == 'flex':
                num_part = 6       
        
            #===============================================================================
            # Pool dir
            pool_dir = '/home/breno/workspace/icseexp/subjects/{}/{}'.format(subject, version)
            with open(os.path.join(pool_dir, 'map_tcs_to_op.pickle'), 'rb') as fin:
                pool = load(fin)
                assert len(pool) == num_part, "Something went wrong! len(pool) ({}) should be == len(ocurrence_probabilities) ({})".format(len(pool), num_part)
            
            fmtype = "fault_matrix_hard"
            with open(os.path.join(pool_dir, 'fault_matrices', '{}.pickle'.format(fmtype)), 'rb') as fin:
                fm = load(fin)           
        
            with open(os.path.join(pool_dir, 'fault_matrices', '{}_key_tc.pickle'.format(fmtype)), 'rb') as fin:
                fm_tc = load(fin)                
                
            all_faults = fm.keys()
        
            
            #--------------------------------------------------
            runids = [int(f) for f in os.listdir(resdir) if os.path.isdir(os.path.join(resdir, f))
                      and f != 'apfd' and f != 'test_suites']
            #last_runid = len(runids)
            
            #if num_runs > last_runid:
            #for _ in range(num_runs):
            while len(runids) < num_runs:
                #print "len(runids): ", len(runids), "num_runs: ", num_runs
                #runids.append("a") 
                #continue
                #runids = [int(f) for f in os.listdir(resdir) if os.path.isdir(os.path.join(resdir, f))]            
                next_runid = len(runids) + 1
                run_outdir = os.path.join(resdir, str(next_runid))
                logging.debug("run_outdir: {}".format(run_outdir))
                if not os.path.isdir(run_outdir):
                    os.makedirs(run_outdir)
                #===========================================================================
                probs = get_op(num_part)
                ocurrence_probabilities = {k: v for (k,v) in zip(range(1, num_part+1), probs)}
                #===============================================================
                # op_log_all = os.path.join(resdir, '{}_{}_OPs.txt'.format(subject, version))
                # op_log = os.path.join(run_outdir, 'OP.txt'.format(subject, version)) 
                # with open(op_log_all, 'a') as fout_ops, \
                #      open(op_log, 'w') as fout_op:
                #     for op in probs:
                #         fout_op.write("{} ".format(op))
                #         fout_ops.write("{} ".format(op))
                #     fout_op.write("\n")                
                #     fout_ops.write("\n")
                #===============================================================
                    
                operations = ocurrence_probabilities.keys()
                partitions = len(ocurrence_probabilities)
                #===========================================================================
                for entity in entities:  
                    print "{}\n{} {} {} (id: {})\n{}".format('='*50, subject, version, entity, next_runid, '='*50)#+1, '='*50)    
                    #===========================================================================
                    # Covrel
                    #===========================================================================
                    #log = open('log.txt', 'w')     
                    #faults_revealed_covrel, faults_revealed_covrel_aux, history = main_new()
                    faults_revealed_covrel, faults_revealed_covrel_aux, history, covrel_ts, covrel_apfd = main_new()
                    print "[COVREL] {}/{} faults revealed: {}".format(len(faults_revealed_covrel), len(all_faults), faults_revealed_covrel)
                    #print "[COVREL] faults_revealed_covrel_aux: ", faults_revealed_covrel_aux
                    #TS + APFD
                    ts_fout = os.path.join(resdir, 'test_suites', '{}-{}-{}.txt'.format("covrel", entity, next_runid))
                    apfd_fout = os.path.join(resdir, 'apfd', '{}-{}-apfd.txt'.format("covrel", entity))
                    for dir_ in ['test_suites', 'apfd']:
                        if not os.path.exists(os.path.join(resdir, dir_)):
                            os.makedirs(os.path.join(resdir, dir_))                                              
                    with open(ts_fout, 'w') as tsfout, \
                         open(apfd_fout, 'a') as apfdfout:
                        for tc in covrel_ts:
                            tsfout.write("{} ".format(tc))                        
                        apfdfout.write(str(covrel_apfd))
                        apfdfout.write("\n")
                    assert covrel_apfd <= 1.0, "Something went wrong. apfd: {}".format(covrel_apfd)
                    # History    
                    hist_pfile = os.path.join(run_outdir, 'history.pickle')
                    hist_tfile = os.path.join(run_outdir, 'history.txt')
                    with open(hist_pfile, 'wb') as pfout, \
                         open(hist_tfile, 'w') as tfout:            
                        dump(history, pfout)
                        pprint.pprint(history, stream=tfout)                            
                    #log.close()
                    # Store information regarding TCs/Faults per partition
                    tcpart = os.path.join(run_outdir, '{}-{}-tcs_per_part.txt'.format("covrel", entity))
                    failpart = os.path.join(run_outdir, '{}-{}-failures_per_part.txt'.format("covrel", entity))
                    fm_iter = os.path.join(run_outdir, '{}-{}-fm_per_iteration.txt'.format("covrel", entity))
                    iter_points = []
                    with open(tcpart, 'w') as tcpartout, \
                        open(failpart, 'w') as failpartout, \
                        open(fm_iter, 'w') as fm_iterout:
                        for i in range(len(history)): # goes through all iterations stored in history 
                            if 'tc_per_part' in history[i]:
                                for numtc in history[i]['tc_per_part']:
                                    tcpartout.write("{} ".format(numtc))
                                tcpartout.write("\n")
                            if 'fail_per_part' in history[i]:
                                for numfail in history[i]['fail_per_part']:
                                    failpartout.write("{} ".format(numfail))
                                failpartout.write("\n")
                            if 'fm_iteration' in history[i]:
                                for f in history[i]['fm_iteration']:
                                    fm_iterout.write("{} ".format(f))
                                fm_iterout.write("\n")
                            if 'tot_tcs' in history[i]:
                                aux = 0
                                if iter_points:
                                    aux = iter_points[-1]
                                iter_points.append(history[i]['tot_tcs'] + aux)                                                        
                    #===========================================================================
                    
                    
                    #===========================================================================
                    # OPBT
                    #===========================================================================    
                    print "{}\n{}\n{}".format("="*80, "OPBT","="*80)
                    logging.debug("iter_points: {}".format(iter_points))
                    #faults_revealed_opbt, tc_per_part_opbt, fail_per_part_opbt, fm_iteration_opbt = opbt(ocurrence_probabilities)
                    faults_revealed_opbt, opbt_ts, opbt_apfd = opbt(ocurrence_probabilities)                    
                    print "[OPBT] {}/{} faults revealed: {}".format(len(faults_revealed_opbt), len(all_faults), faults_revealed_opbt)
                    #---
                    #TS + APFD
                    ts_fout = os.path.join(resdir, 'test_suites', '{}-{}-{}.txt'.format("opbt", entity, next_runid))
                    apfd_fout = os.path.join(resdir, 'apfd', '{}-{}-apfd.txt'.format("opbt", entity))
                    #for dir_ in ['test_suites', 'apfd']:
                        #if not os.path.exists(os.path.join(run_outdir, dir_)):
                            #os.makedirs(os.path.join(run_outdir, dir_))                                              
                    with open(ts_fout, 'w') as tsfout, \
                         open(apfd_fout, 'a') as apfdfout:
                        for tc in opbt_ts:
                            tsfout.write("{} ".format(tc))                        
                        apfdfout.write(str(opbt_apfd))
                        apfdfout.write("\n")
                    assert opbt_apfd <= 1.0, "Something went wrong. apfd: {}".format(opbt_apfd)
                    #---
                    
                    
                    # Store information regarding TCs/Faults per partition
                    #===================================================================
                    # opbt_tcpart = os.path.join(run_outdir, '{}-{}-tcs_per_part.txt'.format("opbt", entity))
                    # opbt_failpart = os.path.join(run_outdir, '{}-{}-failures_per_part.txt'.format("opbt", entity))
                    # opbt_fm_iter = os.path.join(run_outdir, '{}-{}-fm_per_iteration.txt'.format("opbt", entity))
                    # with open(opbt_tcpart, 'w') as opbt_tcpartout, \
                    #     open(opbt_failpart, 'w') as opbt_failpartout, \
                    #     open(opbt_fm_iter, 'w') as opbt_fm_iterout:
                    #         for numtc in tc_per_part_opbt:
                    #             opbt_tcpartout.write("{} ".format(numtc))
                    #         opbt_tcpartout.write("\n")
                    #         for numfail in fail_per_part_opbt:
                    #             opbt_failpartout.write("{} ".format(numfail))
                    #         opbt_failpartout.write("\n")
                    #         for f in fm_iteration_opbt:
                    #             opbt_fm_iterout.write("{} ".format(f))
                    #         opbt_fm_iterout.write("\n")
                    #===================================================================
                    #===========================================================================
                    
                    
                    #===========================================================================
                    # Verify results
                    #===========================================================================
                    if exp_flag != "continue_until_all_faults":
                        assert len(covrel_ts) == len(opbt_ts), "Test suites have different size" 
                    
                    #===========================================================================
                    # Store results
                    #===========================================================================
                    res_covrel = os.path.join(resdir, '{}_{}_{}-covrel.txt'.format(subject, version, entity)) 
                    with open(res_covrel, 'a') as fout:
                        for tc_id in faults_revealed_covrel:
                            fout.write("{} ".format(tc_id))
                        fout.write("\n")
                    #
                    res_opbt = os.path.join(resdir, '{}_{}_{}-opbt.txt'.format(subject, version, entity)) 
                    with open(res_opbt, 'a') as fout:
                        for tc_id in faults_revealed_opbt:
                            fout.write("{} ".format(tc_id))
                        fout.write("\n")
                    #===========================================================================
                    
                    #===========================================================================
                    #CLEANUP
                    cleanup()
                    #===========================================================================
                                
                    #temp_debug()
                runids = [int(f) for f in os.listdir(resdir) if os.path.isdir(os.path.join(resdir, f))
                          and f != 'apfd' and f != 'test_suites']
                
                op_log_all = os.path.join(resdir, '{}_{}_OPs.txt'.format(subject, version))
                op_log = os.path.join(run_outdir, 'OP.txt'.format(subject, version)) 
                with open(op_log_all, 'a') as fout_ops, \
                     open(op_log, 'w') as fout_op:
                    for op in probs:
                        fout_op.write("{} ".format(op))
                        fout_ops.write("{} ".format(op))
                    fout_op.write("\n")                
                    fout_ops.write("\n")


#history = {0: {'sim_fail_rate_balance_factors': [1.0, 1.0, 1.0, 1.0, 1.0], 'tot_tcs': 5, 'fail_rates': [1.0, 1.0, 1.0, 1.0, 1.0], 'IS_prob': [0.0, 0.0, 0.0, 0.0, 0.0], 'tc_per_part': [1, 1, 1, 1, 1]}, 1: {'sim_fail_rate_balance_factors': [0.06666666666666667, 0.4, 0.9333333333333333, 0.9333333333333333, 0.9333333333333333], 'tot_tcs': 66, 'fail_rates': [0.0, 0.0, 0.0, 0.0, 0.0], 'IS_prob': [0.020408163265322368, 0.12244897959187298, 0.2857142857142682, 0.2857142857142682, 0.2857142857142682], 'tc_per_part': [3, 9, 18, 18, 18]}, 2: {'sim_fail_rate_balance_factors': [0.25, 0.125, 0.6875, 0.6875, 0.75], 'tot_tcs': 330, 'fail_rates': [0.0, 0.0, 0.0, 0.0, 0.0], 'IS_prob': [0,0,0,0,0], 'tc_per_part': [66, 66, 66, 66, 66]}, 3: {'sim_fail_rate_balance_factors': [0.25, 0.125, 0.6875, 0.6875, 0.75], 'fail_rates': [0.0, 0.0, 0.0, 0.0, 0.0]}}

#===============================================================================
# INPUT FORMAT REQUIRED BY getAllocation.jar
# args[0]: number of partitions. 
# args[1]: failureRates: must be a sequence of number, separated by a space, representing the observed failure rates (after the execution of the tests in the current iteration)
# args[2]: previousFailureRate: must be a sequence of number, separated by a space, representing the observed failure rates at the previous iteration
# args[3]: similarities: must be a sequence of number, separated by a space, representing the similarities (after the execution of the tests in the current iteration)
# args[4]: previousSimilarityFailureRateBalanceFactors: must be a sequence of number, separated by a space, representing the value of the previousSimilarityFailureRateBalanceFactors at the previous iteration 
# args[5]: profileProbabilities: must be a sequence of number, separated by a space, representing the operational profile probabilities, one per partition 
# args[6]: previousISProbabilities: must be a sequence of number, separated by a space, representing the probabilities assigned by the IS algorithm at the previous iteration
# args[7]: previousTestCasePerPartition: must be a sequence of number, separated by a space, representing the number of test cases per partition suggested by the IS algorithm at the previous iteration
#===============================================================================
    
