#!/usr/bin/env python

import os
from pickle import dump, load

#with open('ic_fault_mapping_hard.pickle', 'r') as p:
#    fm = load(p)

def invert_dict(d):
    aux = {}
    for k in d:
        for v in d[k]:
            aux[v] = k
    return aux

def map_tcs_to_op():
    with open('universe.pickle', 'r') as fin, open('map_tcs_to_op.pickle', 'wb') as fout:
        universe = load(fin)
        pool = {}
        for id_ in universe:
            op = universe[id_]['ic']
            #tc = universe[id_]['tc']
            try:
                pool[op].append(id_)
            except KeyError:
                pool[op] = [id_]
        dump(pool, fout)

def map_tcs_to_op_cluster():                
    with open(universe_fin, 'r') as fin, open(mapping_fin, 'wb') as fout:
        universe = load(fin)
        pool = {}
        for id_ in universe:
            orig_op = universe[id_]['ic']
            #tc = universe[id_]['tc']
            op = equiv_map[orig_op]
            #print "Orig {} will be mapped to {}".format(orig_op, op)
            try:
                pool[op].append(id_)
            except KeyError:
                pool[op] = [id_]
        dump(pool, fout)


def load_map_tcs_to_op():
    #with open('map_tcs_to_op.pickle', 'rb') as fin:
    with open(mapping_fin, 'rb') as fin:    
        pool = load(fin)
    return pool

if __name__ == '__main__':    
    subjects_dir = '/home/breno/workspace/icseexp/subjects/'
    #subject, version = 'gzip', 'v1'
    #subject, version = 'grep', 'v1'
    subject, version = 'sed', 'v2'
    target_dir = os.path.join(subjects_dir, subject, version)
    universe_fin = os.path.join(target_dir, 'universe.pickle')
    mapping_fin = os.path.join(target_dir, 'map_tcs_to_op.pickle')
    
    # OP_X: OP_Y - OP X (for icse17-covrel) is mapped from real OP X (from AST exp)
    if subject == 'grep':
        #=======================================================================
        # aux_map =   {1: range(1,33),
        #               2: range(33,65),
        #               3: range(65,97),
        #               4: range(97,129),
        #               5: range(129,161),
        #               6: range(161,193),}
        #=======================================================================
        aux_map =   {1: range(1,65),
                      2: range(65,97),
                      3: range(97,161),
                      4: range(161,193),}
    elif subject == 'sed':
        #=======================================================================
        # aux_map =   {1: range(1,5),
        #              2: range(5,9),
        #              3: range(9,13),
        #              4: range(13,17),
        #              5: range(17,21),
        #              6: range(21,25),
        #              7: range(25,29),
        #              8: range(29,33),
        #              9: range(33,37),
        #              10: range(37,41),
        #              11: range(41,45),
        #              12: range(45,49)}
        #=======================================================================
        aux_map =   {1: [1,2,3,4],
                     2: [5,6,9,10,13,14,17,18,21,22,25,26,29,30,33,34,37,38,41,42,45,46],
                     3: [7,8,11,12,15,16,19,20,23,24,27,28,31,32,35,36,39,40,43,44,47,48],}
    equiv_map = invert_dict(aux_map)
    #==========
    
    #map_tcs_to_op()
    
    map_tcs_to_op_cluster()
    pool = load_map_tcs_to_op()
    for key in pool:
        print "OP {} contains {} TCs".format(key, len(pool[key]))
        #print key, pool[key][:10] 
    print "Total TCs: {}".format(sum([len(l) for l in pool.values()]))
            

    
